# coding: utf-8

"""
    VRt.Routing [RO]

    The version of the OpenAPI document: 6.13.2112

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conint, conlist
from vrt_lss_routing.models.geo_settings import GeoSettings
from vrt_lss_routing.models.transport_type import TransportType
from vrt_lss_routing.models.waypoint import Waypoint

class RouteTask(BaseModel):
    """
    Task for route planning. The departure time considers traffic jams. 
    """
    waypoints: conlist(Waypoint, max_items=15001, min_items=2) = Field(..., description="Array of geographical points to build path between them.")
    transport_type: Optional[TransportType] = None
    geo_settings: Optional[GeoSettings] = None
    departure_time: Optional[datetime] = Field(None, description="Departure date and time according to the [RFC 3339, section 5.6 (ISO 8601)](https://tools.ietf.org/html/rfc3339#section-5.6).")
    result_timezone: Optional[conint(strict=True, le=12, ge=-12)] = Field(0, description="Time zone for calculation results.")
    detail: Optional[StrictBool] = Field(False, description="Planning a detailed route.")
    full_segments: Optional[StrictBool] = Field(True, description="Return full segments list. ")
    polyline: Optional[StrictBool] = Field(True, description="Generate a polyline between points.")
    __properties = ["waypoints", "transport_type", "geo_settings", "departure_time", "result_timezone", "detail", "full_segments", "polyline"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RouteTask:
        """Create an instance of RouteTask from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in waypoints (list)
        _items = []
        if self.waypoints:
            for _item in self.waypoints:
                if _item:
                    _items.append(_item.to_dict())
            _dict['waypoints'] = _items
        # override the default output from pydantic by calling `to_dict()` of geo_settings
        if self.geo_settings:
            _dict['geo_settings'] = self.geo_settings.to_dict()
        # set to None if departure_time (nullable) is None
        # and __fields_set__ contains the field
        if self.departure_time is None and "departure_time" in self.__fields_set__:
            _dict['departure_time'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RouteTask:
        """Create an instance of RouteTask from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return RouteTask.parse_obj(obj)

        _obj = RouteTask.parse_obj({
            "waypoints": [Waypoint.from_dict(_item) for _item in obj.get("waypoints")] if obj.get("waypoints") is not None else None,
            "transport_type": obj.get("transport_type"),
            "geo_settings": GeoSettings.from_dict(obj.get("geo_settings")) if obj.get("geo_settings") is not None else None,
            "departure_time": obj.get("departure_time"),
            "result_timezone": obj.get("result_timezone") if obj.get("result_timezone") is not None else 0,
            "detail": obj.get("detail") if obj.get("detail") is not None else False,
            "full_segments": obj.get("full_segments") if obj.get("full_segments") is not None else True,
            "polyline": obj.get("polyline") if obj.get("polyline") is not None else True
        })
        return _obj

